package cz.muni.pa165.account;

import cz.muni.pa165.account.data.repository.AccountRepository;
import cz.muni.pa165.account.service.AccountService;
import cz.muni.pa165.core.exception.ResourceNotFoundException;
import java.util.Optional;
import org.junit.jupiter.api.BeforeEach;
import org.mockito.Mock;
import org.mockito.Mockito;
import org.mockito.MockitoAnnotations;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;

public abstract class AccountTestBase {

    @Mock
    protected AccountRepository repository;

    protected AccountService service;

    @BeforeEach
    public void setup() {
        MockitoAnnotations.openMocks(this);
        this.mockRepositoryMethods();
        service = new AccountService(repository);
    }

    private void mockRepositoryMethods() {
        Mockito
            .when(repository.findById(Mockito.anyLong()))
            .thenThrow(ResourceNotFoundException.class);
        Mockito
            .when(repository.findById(MockedEntities.JOHN_WICK.getId()))
            .thenReturn(Optional.of(MockedEntities.JOHN_WICK));

        Mockito
            .when(repository.findAll(Mockito.any(Pageable.class)))
            .thenReturn(new PageImpl<>(MockedEntities.ACCOUNTS));
        Mockito
            .when(repository.save(MockedEntities.JOHN_WICK))
            .thenReturn(MockedEntities.JOHN_WICK);
    }
}
