package cz.muni.pa165.movie;

import cz.muni.pa165.movie.data.model.Movie;
import cz.muni.pa165.movie.data.model.Person;
import java.util.List;
import java.util.Set;

public class MockedEntities {

    public static final Person JOHNNY_DEPP;
    public static final Person ORLANDO_BLOOM;
    public static final Person KEIRA_KNIGHTLEY;
    public static final Set<Person> ACTORS;
    public static final Person GORE_VERBINSKI;
    public static final Set<Long> GENRES = Set.of(1L, 5L);
    public static final Set<String> IMAGES = Set.of(
        "https://example.com/image1.jpg",
        "https://example.com/image2.jpg"
    );
    public static final Movie PIRATES_OF_THE_CARIBBEAN;
    public static final List<Movie> MOVIES;

    static {
        JOHNNY_DEPP = new Person();
        JOHNNY_DEPP.setName("Johnny");
        JOHNNY_DEPP.setSurname("Depp");

        ORLANDO_BLOOM = new Person();
        ORLANDO_BLOOM.setName("Orlando");
        ORLANDO_BLOOM.setSurname("Bloom");

        KEIRA_KNIGHTLEY = new Person();
        KEIRA_KNIGHTLEY.setName("Keira");
        KEIRA_KNIGHTLEY.setSurname("Knightley");

        ACTORS = Set.of(JOHNNY_DEPP, ORLANDO_BLOOM, KEIRA_KNIGHTLEY);

        GORE_VERBINSKI = new Person();
        GORE_VERBINSKI.setName("Gore");
        GORE_VERBINSKI.setSurname("Verbinski");

        PIRATES_OF_THE_CARIBBEAN = new Movie();
        PIRATES_OF_THE_CARIBBEAN.setTitle("Pirates of the Caribbean");
        PIRATES_OF_THE_CARIBBEAN.setDescription(
            "A pirate captain and his crew are in search of a legendary treasure."
        );
        PIRATES_OF_THE_CARIBBEAN.setActors(ACTORS);
        PIRATES_OF_THE_CARIBBEAN.setDirector(GORE_VERBINSKI);
        PIRATES_OF_THE_CARIBBEAN.setGenreIds(GENRES);
        PIRATES_OF_THE_CARIBBEAN.setImages(IMAGES);

        GORE_VERBINSKI.getMoviesDirected().add(PIRATES_OF_THE_CARIBBEAN);
        ACTORS.forEach(actor ->
            actor.getMoviesActedIn().add(PIRATES_OF_THE_CARIBBEAN)
        );

        MOVIES = List.of(PIRATES_OF_THE_CARIBBEAN);
    }
}
